Iannix {
	var <responders, <iannixAddress, <scIP, <objects, <>groups, <>globalActions, <>transportActions, transportFunctions, <>idOffsets, <messagePeriods;
	var <speed;
	var <synthGroup, t_warned, c_warned;
	var <debug;
	
	*new { |iannixIP = "127.0.0.1", iannixPort = 1234, sclangIP = "127.0.0.1"|
		^super.new.init(iannixIP, iannixPort, sclangIP);
	}
	
	createDictionaries {
//		objects = ( cursors:(offset: 0), curves:(offset: 1000),triggers: (offset: 2000));
		objects = ( cursors:(), curves:(),triggers:());
		groups = ();
		globalActions  = (
			triggers: {t_warned ?? {"no trigger action defined".warn; t_warned=true}},
			 cursors: {c_warned ?? {"no cursor action defined".warn; c_warned=true}} 
		);
		responders = ();
		transportFunctions = ();
		[\play, \stop, \fastrewind].do {|message| transportFunctions[message] = {("iannix: " + message).inform; transportActions[message].value } };
		transportActions = (\play: {synthGroup !? {synthGroup.run(true);synthGroup.set(\trigFade, 1.0) } }, \stop: {synthGroup !? { synthGroup.set(\trigFade, 0.0); {0.2.wait; synthGroup.run(false) }.fork } }, 
		\fastrewind: {synthGroup !? {synthGroup.run(false)}});
		idOffsets = (\triggers: 2000, \curves: 1000, \cursors: 0);
		messagePeriods = (\trigger: 1, \cursor: 20)
	}
	
	init {|ip, iannixPort, sclangIP|
		scIP = sclangIP;
		this.createDictionaries;
		speed = 1;
		this.connect(ip, iannixPort);
	}
	
	connect  {|ip = "127.0.0.1", port = 1234|
		iannixAddress !? {iannixAddress.disconnect};
		iannixAddress = NetAddr(ip, port);
//		iannixAddress = nil; //DEBUG
		this.listen(\transport);
//		^this;
	
	}
		
	listen{ |type = \triggers, on = true|
			var typeMsg, oscPrefix, removeMsg, message, object, objectID, action, cutS;
			removeMsg = (type.asString + "Responder Removed");
	
		    responders[type] !? {responders[type].remove;  };
		    if (on) {
		    typeMsg = type.asString;
		    if (type != \transport) {typeMsg = typeMsg[..typeMsg.size-2]};//truncating ending 's'
		    oscPrefix = ("\/"++typeMsg).asSymbol;
		    ("Iannix: listening to" + type++"...").inform;
			responders[type] = OSCresponderNode(iannixAddress, oscPrefix, { | time, responder, msg | //I don't get it, but putting iannixAdress here does work... DEBUG netAdress
//				if (debug) {msg.postln};	

				message = [msg[1].asInteger] ++ msg[2..]; //objectID as Integer
				if (oscPrefix != '/transport' )
				{
					objectID = message.first;
					object = objects[type][objectID];
					object ?? { object = IannixObject.preNew(typeMsg, this, objectID) };
					
					action = object.action ? globalActions[type];
					action.(message);
				}
				{
					transportFunctions[msg[1]].value;
//					[\triggers, \cursors, \curves].do {|type|
//						var family ;
//						family = objects[type];
//						if (family.isEmpty.not)
//							{i = family.keys.asArray.sort.last+1 }
//							{i = idOffsets[type]}
//						id = i.asInteger; 
//						objects[type][id] = this;
				}
			}).add;
		    }{ removeMsg.inform };
		this.add2cmdPeriod({ responders[type].remove; removeMsg.inform; this.stop});
		^this;

	}
	
	removeResponders {
		responders.do {|resp| resp.remove };
		responders = ();
	}
	
	remove {|target| //object or group name
		case 
			{ target.isKindOf(IannixObject)}{ target.remove } 
			{ target.isKindOf(String)}{
				target = target.asSymbol;
				if (this.groups[target].notNil) { 
					this.groups[target].do {| object | object.remove };
					this.groups.removeAt(target);
					iannixAddress.sendMsg("/iannix/remove", target);
				}
			}
	}
					
					
					
		
	removeAll {|total=false| //if total, remove all objects in Iannix.app ( even  objects not created from sc )
		if (total) {iannixAddress.sendMsg("/iannix/clear") };
		this.removeResponders;
		this.createDictionaries;
	}
	
	clear {
		this.removeAll(true);
	}
	
	resetScore {|zoom=100, total=false| //remove local representations of iannix objects, and responders (and even  objects not created from sc, if total ==  true)
		objects.do {|dict| dict.do {|innerObject| innerObject.remove} }; //objects in Iannix.app
		this.zoom_(zoom);
		this.removeAll(total);
	}
	
	createSynthGroup {|server|
		server ?? { server = Server.default };
		server.waitForBoot ({
			synthGroup ?? {synthGroup = Group.new};
			("Iannix: new synth group created ("++ synthGroup.nodeID ++"). transport actions operate on it (run true, false)").inform;
			synthGroup.run(false);
		});
		this.add2cmdPeriod({ synthGroup !? { synthGroup = nil; "iannix synth group deleted".inform } });
		^this;
		
	}
	
	add2cmdPeriod { | func |
		CmdPeriod.add(func);
	}

	//transport 
	
	play {|speed|
		speed !? {this.speed = speed};
		iannixAddress.sendMsg("/iannix/play", this.speed);
		transportFunctions[\play].value;
	}
	stop {
		iannixAddress.sendMsg("/iannix/stop");
		transportFunctions[\stop].value;
	}
	fastrewind {
		iannixAddress.sendMsg("/iannix/fastrewind");
		transportFunctions[\fastrewind].value;
	}
	
	speed_ {|value=1|
		iannixAddress.sendMsg("/iannix/speed", value);
		speed = value;
	}
	
	//general commands
	
	zoom_ {|value=100|
		iannixAddress.sendMsg("/iannix/zoom", value);
	}
	
	center_ {|x=0, y=0|
		iannixAddress.sendMsg("/iannix/center", x, y);
	}
		
	//objects
	
	/* 
	(useful for mirroring the existing iannix.app objects, until iannix team implement a dump message for us)
	//put send=false to register (in sc)  any object already existing in IanniX.app
	*/
	
	triggers {
		^this.objects[\triggers];
	}
	
	curves {
		^this.objects[\curves];
	}
	
	cursors {
		^this.objects[\cursors];
	}

	//creation
	trigger {| xPos=0, yPos=0, zPos=0, send = true | 
		var trg;
		trg = IannixTrigger(this);
		if (send) { trg.send; trg.position_(xPos, yPos, zPos) };
		^trg;
	}
	
	curve {|pointsArray, xPos=0, yPos=0, zPos=0, send = true| //if pointsArray, a curve is added in Iannix
		var crv;
		crv = IannixCurve(this);
		if (send) { 
			crv.send;
			crv.points_(pointsArray);
			crv.position_(xPos, yPos, zPos) ;
		};		
		^crv;
	}

	cursor {|curve, send = true |
		var crs;
		crs = IannixCursor(this);
		if (send) {
			crs.send;
			curve !? {crs.putOnCurve(curve)}
			};
			curve !? {curve.childs.add(crs)}; //useful when deleting a curve
		^crs;
	}
	
	activate {|groupName, bool=true|
		groupName ?? { groupName = "all" };
		iannixAddress.sendMsg("/iannix/setActive", groupName, if (bool){1}{0} )
	}
	
//	debug { |flag= true| 
//		if (flag ) {debug = true} }
		
}